#ifndef NFILEINTERNET_H
#define NFILEINTERNET_H

#include <string>
#include <memory>
#include <afxinet.h>
#include "NFile.h"

class NFileInternet : public NFile
{
private:
	CInternetSession m_Session;
	std::auto_ptr<CStdioFile> m_pFile;
	bool m_bIsOpen;
public:
	NFileInternet(const std::string& url);
	virtual ~NFileInternet();
	virtual bool IsOpen()const;
	virtual void Close();
	virtual int Read(void* buffer, int size);
	virtual int Write(const void* buffer, int size);
	virtual void Seek(long long size, int base);
	virtual void SetBuffer(int size);
	virtual long long GetSize();
};

#endif
