#include "stdafx.h"
#include <sstream>
#include <algorithm>
#include "MemoryCard.h"
#include "Log.h"
#include "Utility.h"

using namespace std;

enum FTP_ENUM{
	FTP_PERMISSION,
	FTP_RESERVE0,
	FTP_RESERVE1,
	FTP_RESERVE2,
	FTP_FILE_SIZE,
	FTP_MONTH,
	FTP_DAY,
	FTP_YEAR,
	FTP_NAME,
	NUMBER_FTP_ENUM
};

const string strMonth[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

void MemoryCard::FILE_DATA::SetFtpListLine(const std::string& ftp_list_line)
{
	Log::Add("\n" + ftp_list_line);
	istringstream iss(ftp_list_line);
	string str[NUMBER_FTP_ENUM];
	for (int i = 0; i < FTP_NAME; ++i){
		iss >> str[i];
	}
	getline(iss, str[FTP_NAME]);

	SetPermissionString(str[FTP_PERMISSION]);
	int year = (int)Utility::ToInt(str[FTP_YEAR]);
	year = max(year, 1980);
	int month = (int)distance(strMonth, find(strMonth, strMonth + 12, str[FTP_MONTH])) + 1;
	if (month == 13){
		Log::Add("G[ : pP̒Ԃ肪ԈĂ܂ FtpClient::FILE_DATA " + str[FTP_MONTH]);
		month = 1;
	}
	int day = std::max(1, (int)Utility::ToInt(str[FTP_DAY]));
	time = CTime(year, month, day, 0, 0, 0);
	name = str[FTP_NAME];
	name = name.substr(name.find_first_not_of(' '));
	file_size = (int)Utility::ToInt(str[FTP_FILE_SIZE]);
}

enum PS2CLIENT_ENUM{
	PS2CLIENT_PERMISSION,
	PS2CLINET_FILE_SIZE,
	PS2CLIENT_DATE,
	PS2CLIENT_TIME,
	PS2CLIENT_NAME,
	NUMBER_PS2CLIENT
};

void MemoryCard::FILE_DATA::SetPS2ClientListLine(const std::string &ps2client_list_line)
{
	//Log::Add(ps2client_list_line);
	istringstream iss(ps2client_list_line);
	string str_permission;
	iss >> str_permission;
	SetPermissionString(str_permission);
	iss >> file_size;
	string date;
	iss >> date;
	int year = (int)Utility::ToInt(date.substr(6));
	int month = std::max((int)Utility::ToInt(date.substr(0, 2)), 1);
	int day = std::max((int)Utility::ToInt(date.substr(3, 2)), 1);
	string str_time;
	iss >> str_time;
	int hour = (int)Utility::ToInt(str_time.substr(0, 2));
	int minute = (int)Utility::ToInt(str_time.substr(3, 2));
	int second = (int)Utility::ToInt(str_time.substr(6, 2));
	time = CTime(year, month, day, hour, minute, second);
	getline(iss, name);
	Utility::FilterNonPrintableChar(name);
	name = name.substr(name.find_first_not_of(' '));
	//iss >> name;
}

void MemoryCard::FILE_DATA::SetPermissionString(const std::string& str)
{
	is_directory= (str[0] == 'd');
	for (int i = 0; i < 3; ++i){
		permission[i] = 0;
		for (int j = 0; j < 3; ++j){
			if (str[i * 3 + j + 1] != '-'){
				permission[i] |= (1 << j);
			}
		}
	}
}
/*
bool MemoryCard::SetMemoryCardSlot(int index)
{
	if (m_iValidMemoryCardSlot | (1 << index)){
		m_iCurrentMemoryCardSlot = index;
		return true;
	}
	return false;
}
*/
