#ifndef SAVE_FILE_BASE_H
#define SAVE_FILE_BASE_H

#include <boost/shared_ptr.hpp>
#include <vector>
#include <string>
#include <map>

class SaveFileBase
{
public:
	struct FILE_DATA{
		std::string file_name;
		std::vector<char> body;
		CFileStatus status;
	};
	typedef std::vector<boost::shared_ptr<FILE_DATA> > FOLDER_DATA;

	class SortFile : public std::binary_function<boost::shared_ptr<FILE_DATA>, boost::shared_ptr<FILE_DATA>, bool>
	{
	public:
		bool operator()(const boost::shared_ptr<FILE_DATA>& lh, const boost::shared_ptr<FILE_DATA>& rh)const
		{
			return lh->status.m_ctime.GetSecond() < rh->status.m_ctime.GetSecond();
		}
	};

protected:
	//tH_,t@Cf[^̔z
	std::map<std::string, FOLDER_DATA> m_mapFileData;
public:
	virtual ~SaveFileBase(){}
	virtual bool Save(const std::string& folder_path)const = 0;
	virtual bool Load(const std::string& file_path) = 0;
	const std::map<std::string, FOLDER_DATA>& GetData()const{return m_mapFileData;}
	void SetData(const std::map<std::string, FOLDER_DATA>& data){m_mapFileData = data;}

};

#endif
